; demo.s
;
; This program displays an 8-bit signed number on the alphanumeric
; display, and counts it up.
;
; Mark J. Sebern
; MSOE
; 12 April 1994 (updated 13 December 1998)
;

        .globl disp8   ; Declare external routine.

; Define some symbols for port addresses and constants.

        .area   ABS (ABS)

pioc    =     0x1002   ; Port control register
ddrc    =     0x1007   ; Data direction register C

; Define some symbols for port addresses and constants.

        .area   STACK (REL,CON)

        .blkb   256    ; Stack area.
stkhi::                ; Initial value for stack pointer.

; Set location counter for "ROM" code area.

        .area   ROMCODE (REL,CON)

; Set up the stack pointer.
; Initialize the I/O ports for the display and keypad.

start::
	lds     #stkhi  ; Set initial stack pointer value.
	ldaa    #0x02   ; Set I/O port configuration.
	staa    pioc
	ldaa    #0x0F   ; Set C3-C0 as outputs.
	staa    ddrc

	clra            ; Clear number.

; Main program loop:
;    Display number.
;    Delay.

mainloop:
	jsr     disp8   ; Display it.
        inca            ; Increment number.
        ldx     #10000  ; Set delay.
        jsr     delay   ; Wait.
	bra     mainloop

; delay - Subroutine to wait a while.
;
; Inputs:
;       X - Relative delay time.
;
; Outputs:
;       All registers are preserved.
;
delay:
	pshx            ; Save registers.
1$:
	dex		; Decrement X register.
        bne     1$	; Loop if not zero.

        pulx            ; Restore registers.
	rts             ; Return to caller.
